vgp.vector.translation

## Class PjTranslation

- java.lang.Object
- - jv.object.PsObject
  - - jv.project.PjProject
    - - vgp.vector.translation.PjTranslation

- All Implemented Interfaces:
    java.awt.event.ActionListener, java.io.Serializable, java.lang.Cloneable, java.util.EventListener, PsTimeListenerIf, PsUpdateIf, PvPickListenerIf

      public class PjTranslation
      extends PjProject
      implements java.awt.event.ActionListener

  Pick a polygon on a surface and parallel translate a vector long the polygon.
  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class jv.object.PsObject

      `HAS_BOUNDARY_PANEL, HAS_CONFIG_PANEL, HAS_INFO_PANEL, HAS_LABEL_PANEL, HAS_MATERIAL_PANEL, HAS_TEXTURE_PANEL, HAS_VECTOR_PANEL, INSPECTOR_INFO, INSPECTOR_INFO_EXT, IS_DELETED, IS_FIXED, IS_FOCUSSED, IS_PICKED, IS_SELECTED, IS_USED, NUM_TAGS`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PjTranslation()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `actionPerformed(java.awt.event.ActionEvent event)` Handles action events.
    `void` | `dragInitial(PvPickEvent event)` Drag an arbitrary point along a geometry, point may lie inside an element.
    `java.lang.String` | `getFileName()` Get current file name.
    `void` | `init()` Initialize and reset project, stops the running animation if any.
    `boolean` | `load()` Loads geometry via PjImportModel and then calls load().
    `void` | `pickInitial(PvPickEvent event)` Pick an arbitrary point on a geometry, point may lie inside an element.
    `void` | `reset()`
    `void` | `setFileName(java.lang.String fullFileName)` Sets filename from outside of this project.
    `void` | `setGeometry(PgElementSet geom)` Sets the geometry loaded from PjImportModel and then triangulates, updates the number of elements, gets a vector field and fits that all in the display.
    `void` | `start()` Start project with loading geometry from file.
    `static int` | `translate(PgPolygonOnElementSet poly, double end, PdBaryDir vector, PdBary outbase, PdBaryDir outvec)` Parallel translate a given vector along a polygon on elementSet.
    `boolean` | `update(java.lang.Object event)` Update all inspector panels, send update to all registered update listeners and finally update parent.

    - ### Methods inherited from class jv.project.PjProject

      `addDisplay, addGeometry, addGeometry, dispose, dragDisplay, dragVertex, fitDisplays, getAnimation, getDisplay, getDisplays, getGeometry, getGeometry, getNumGeometries, getParameter, getViewer, hasAnimation, hasDisplay, isEnabledAutoFit, markVertices, pickDisplay, pickVertex, removeDisplay, removeGeometries, removeGeometry, selectDisplay, selectGeometry, setAnimation, setBackColor, setBorderType, setDisplay, setEnabledAutoFit, setGeometry, setParameter, setTime, setViewer, stop, unmarkVertices`

    - ### Methods inherited from class jv.object.PsObject

      `addInspector, addUpdateListener, assureInspector, clearTag, clone, clone, clone, copy, getFather, getInfoPanel, getInspector, getName, getNumObjects, getSymbol, hasInspector, hasTag, hasUpdateListener, instanceOf, instanceOf, newInspector, newInspector, removeInspector, removeInspector, removeUpdateListener, setName, setParent, setSymbol, setTag, toString, updatePanels`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface jv.anim.PsTimeListenerIf

      `getName`

    - ### Methods inherited from interface jv.project.PvPickListenerIf

      `getName`

- - ### Constructor Detail

    - #### PjTranslation

          public PjTranslation()

  - ### Method Detail

    - #### init

          public void init()

      Description copied from class: `PjProject`
      Initialize and reset project, stops the running animation if any. Does not reset any registered display nor geometry. They must be reset individually in each subclass.
      Overrides:
        `init` in class `PjProject`

    - #### reset

          public void reset()

    - #### start

          public void start()

      Start project with loading geometry from file.
      Overrides:
        `start` in class `PjProject`
      See Also:
        `PvViewerIf.start()`, `PjProject.isEnabledAutoFit()`

    - #### getFileName

          public java.lang.String getFileName()

      Get current file name.

    - #### setFileName

          public void setFileName(java.lang.String fullFileName)

      Sets filename from outside of this project. Replaces the default file name. Must call load() after setting the file name.
      Parameters:
        `fullFileName` - fully specified file name including code base, or URL.
      See Also:
        `load()`

    - #### actionPerformed

          public void actionPerformed(java.awt.event.ActionEvent event)

      Handles action events.
      Specified by:
        `actionPerformed` in interface `java.awt.event.ActionListener`

    - #### load

          public boolean load()

      Loads geometry via PjImportModel and then calls load().
      See Also:
        `setGeometry(PgElementSet)`

    - #### setGeometry

          public void setGeometry(PgElementSet geom)

      Sets the geometry loaded from PjImportModel and then triangulates, updates the number of elements, gets a vector field and fits that all in the display.

    - #### update

          public boolean update(java.lang.Object event)

      Description copied from class: `PsObject`
      Update all inspector panels, send update to all registered update listeners and finally update parent. Each of those updates has this object as event independent of the argument of this method.

      Central update method of this object. Must be overwritten if this class receives unknown events, say, from new children. Any subclass must class invoke super.update(event) on all events it does handle itself.

      Specified by:
        `update` in interface `PsUpdateIf`
      Overrides:
        `update` in class `PsObject`
      Parameters:
        `event` - carries a lot of information
      Returns:
        true if event has been handled, otherwise false
      See Also:
        `PsObject.setParent(PsUpdateIf)`, `PsObject.getFather()`, `PsObject.addUpdateListener(PsUpdateIf)`

    - #### dragInitial

          public void dragInitial(PvPickEvent event)

      Description copied from class: `PjProject`
      Drag an arbitrary point along a geometry, point may lie inside an element. This method invokes `pickInitial(PvPickEvent)` and should be overwritten.
      Specified by:
        `dragInitial` in interface `PvPickListenerIf`
      Overrides:
        `dragInitial` in class `PjProject`
      Parameters:
        `event` - Pick event issued by the display
      See Also:
        `PvPickListenerIf`

    - #### pickInitial

          public void pickInitial(PvPickEvent event)

      Description copied from class: `PjProject`
      Pick an arbitrary point on a geometry, point may lie inside an element. This method does nothing and must be overwritten.
      Specified by:
        `pickInitial` in interface `PvPickListenerIf`
      Overrides:
        `pickInitial` in class `PjProject`
      Parameters:
        `event` - Pick event issued by the display
      See Also:
        `PvPickListenerIf`

    - #### translate

          public static int translate(PgPolygonOnElementSet poly,
                      double end,
                      PdBaryDir vector,
                      PdBary outbase,
                      PdBaryDir outvec)

      Parallel translate a given vector along a polygon on elementSet. The vector is given at the first vertex of the polygon.
      Parameters:
        `poly` - polygon on elementSet
        `end` - distance to which the vector is translated
        `vector` - initial vector as barycentric direction
        `outbase` - base point of translated vector in barycentric coordinates
        `outvec` - translated vector as barycentric direction
      Returns:
        element index which contains the translated vector.

"

The software JavaView? is copyright protected. All Rights Reserved.
"